gitit-0.15.1.2: Wiki using happstack, git or darcs, and pandoc.

Safe Haskell | Safe-Inferred
Language | Haskell2010

Network.Gitit.Types

Description

Types for Gitit modules.

Synopsis

- data PageType
  - = Markdown
  - | CommonMark
  - | RST
  - | LaTeX
  - | HTML
  - | Textile
  - | Org
  - | DocBook
  - | MediaWiki
- data FileStoreType
  - = Git
  - | Darcs
  - | Mercurial
- data MathMethod
  - = MathML
  - | WebTeX String
  - | RawTeX
  - | MathJax String
- data AuthenticationLevel
  - = Never
  - | ForModify
  - | ForRead
- data Config = Config {
  - repositoryPath :: FilePath
  - repositoryType :: FileStoreType
  - defaultPageType :: PageType
  - defaultExtension :: String
  - mathMethod :: MathMethod
  - defaultLHS :: Bool
  - showLHSBirdTracks :: Bool
  - withUser :: Handler -> Handler
  - requireAuthentication :: AuthenticationLevel
  - authHandler :: Handler
  - userFile :: FilePath
  - sessionTimeout :: Int
  - templatesDir :: FilePath
  - logFile :: FilePath
  - logLevel :: Priority
  - staticDir :: FilePath
  - pluginModules :: [String]
  - tableOfContents :: Bool
  - maxUploadSize :: Integer
  - maxPageSize :: Integer
  - address :: String
  - portNumber :: Int
  - debugMode :: Bool
  - frontPage :: String
  - noEdit :: [String]
  - noDelete :: [String]
  - defaultSummary :: String
  - deleteSummary :: String
  - accessQuestion :: Maybe (String, [String])
  - disableRegistration :: Bool
  - useRecaptcha :: Bool
  - recaptchaPublicKey :: String
  - recaptchaPrivateKey :: String
  - rpxDomain :: String
  - rpxKey :: String
  - compressResponses :: Bool
  - useCache :: Bool
  - cacheDir :: FilePath
  - mimeMap :: Map String String
  - mailCommand :: String
  - resetPasswordMessage :: String
  - markupHelp :: Text
  - useFeed :: Bool
  - baseUrl :: String
  - useAbsoluteUrls :: Bool
  - wikiTitle :: String
  - feedDays :: Integer
  - feedRefreshTime :: Integer
  - pandocUserData :: Maybe FilePath
  - xssSanitize :: Bool
  - recentActivityDays :: Int
  - githubAuth :: GithubConfig
  }
- data Page = Page {
  - pageName :: String
  - pageFormat :: PageType
  - pageLHS :: Bool
  - pageTOC :: Bool
  - pageTitle :: String
  - pageCategories :: [String]
  - pageText :: String
  - pageMeta :: [(String, String)]
  }
- newtype SessionKey = SessionKey Integer
- data SessionData
- data SessionGithubData
- sessionData :: String -> SessionData
- sessionGithubData :: SessionData -> Maybe SessionGithubData
- sessionDataGithubStateUrl :: String -> String -> SessionData
- sessionUser :: SessionData -> Maybe String
- sessionGithubState :: SessionGithubData -> String
- sessionGithubDestination :: SessionGithubData -> String
- data User = User {
  - uUsername :: String
  - uPassword :: Password
  - uEmail :: String
  }
- data Sessions a = Sessions {
  - unsession :: Map SessionKey a
  }
- data Password = Password {
  - pSalt :: String
  - pHashed :: String
  }
- data GititState = GititState {
  - sessions :: Sessions SessionData
  - users :: Map String User
  - templatesPath :: FilePath
  - renderPage :: PageLayout -> Html -> Handler
  - plugins :: [Plugin]
  }
- class Monad m => HasContext m
- modifyContext :: HasContext m => (Context -> Context) -> m ()
- getContext :: HasContext m => m Context
- type ContentTransformer = StateT Context GititServerPart
- data Plugin
  - = PageTransform (Pandoc -> PluginM Pandoc)
  - | PreParseTransform (String -> PluginM String)
  - | PreCommitTransform (String -> PluginM String)
- data PluginData = PluginData {
  - pluginConfig :: Config
  - pluginUser :: Maybe User
  - pluginRequest :: Request
  - pluginFileStore :: FileStore
  }
- type PluginM = ReaderT PluginData (StateT Context IO)
- runPluginM :: PluginM a -> PluginData -> Context -> IO (a, Context)
- data Context = Context {
  - ctxFile :: String
  - ctxLayout :: PageLayout
  - ctxCacheable :: Bool
  - ctxTOC :: Bool
  - ctxBirdTracks :: Bool
  - ctxCategories :: [String]
  - ctxMeta :: [(String, String)]
  }
- data PageLayout = PageLayout {
  - pgPageName :: String
  - pgRevision :: Maybe String
  - pgPrintable :: Bool
  - pgMessages :: [String]
  - pgTitle :: String
  - pgScripts :: [String]
  - pgShowPageTools :: Bool
  - pgShowSiteNav :: Bool
  - pgMarkupHelp :: Maybe Text
  - pgTabs :: [Tab]
  - pgSelectedTab :: Tab
  - pgLinkToFeed :: Bool
  }
- data Tab
  - = ViewTab
  - | EditTab
  - | HistoryTab
  - | DiscussTab
  - | DiffTab
- data Recaptcha = Recaptcha {
  - recaptchaChallengeField :: String
  - recaptchaResponseField :: String
  }
- data Params = Params {
  - pUsername :: String
  - pPassword :: String
  - pPassword2 :: String
  - pRevision :: Maybe String
  - pDestination :: String
  - pForUser :: Maybe String
  - pSince :: Maybe UTCTime
  - pRaw :: String
  - pLimit :: Int
  - pPatterns :: [String]
  - pGotoPage :: String
  - pFileToDelete :: String
  - pEditedText :: Maybe String
  - pMessages :: [String]
  - pFrom :: Maybe String
  - pTo :: Maybe String
  - pFormat :: String
  - pSHA1 :: String
  - pLogMsg :: String
  - pEmail :: String
  - pFullName :: String
  - pAccessCode :: String
  - pWikiname :: String
  - pPrintable :: Bool
  - pOverwrite :: Bool
  - pFilename :: String
  - pFilePath :: FilePath
  - pConfirm :: Bool
  - pSessionKey :: Maybe SessionKey
  - pRecaptcha :: Recaptcha
  - pResetCode :: String
  - pRedirect :: Maybe Bool
  }
- data Command = Command (Maybe String)
- data WikiState = WikiState {
  - wikiConfig :: Config
  - wikiFileStore :: FileStore
  }
- type GititServerPart = ServerPartT (ReaderT WikiState IO)
- type Handler = GititServerPart Response
- fromEntities :: String -> String
- data GithubConfig
- oAuth2 :: GithubConfig -> OAuth2
- org :: GithubConfig -> Maybe Text
- githubConfig :: OAuth2 -> Maybe Text -> GithubConfig

# Documentation

data PageType Source #

Constructors

Markdown |
CommonMark |
RST |
LaTeX |
HTML |
Textile |
Org |
DocBook |
MediaWiki |

#### Instances

Instances details

Read PageType Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS PageType Source # readList :: ReadS [PageType] Source # readPrec :: ReadPrec PageType Source # readListPrec :: ReadPrec [PageType] Source #
Show PageType Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> PageType -> ShowS Source # show :: PageType -> String Source # showList :: [PageType] -> ShowS Source #
Eq PageType Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: PageType -> PageType -> Bool Source # (/=) :: PageType -> PageType -> Bool Source #

data FileStoreType Source #

Constructors

Git |
Darcs |
Mercurial |

#### Instances

Instances details

Show FileStoreType Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> FileStoreType -> ShowS Source # show :: FileStoreType -> String Source # showList :: [FileStoreType] -> ShowS Source #

data MathMethod Source #

Constructors

MathML |
WebTeX String |
RawTeX |
MathJax String |

#### Instances

Instances details

Read MathMethod Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS MathMethod Source # readList :: ReadS [MathMethod] Source # readPrec :: ReadPrec MathMethod Source # readListPrec :: ReadPrec [MathMethod] Source #
Show MathMethod Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> MathMethod -> ShowS Source # show :: MathMethod -> String Source # showList :: [MathMethod] -> ShowS Source #
Eq MathMethod Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: MathMethod -> MathMethod -> Bool Source # (/=) :: MathMethod -> MathMethod -> Bool Source #

data AuthenticationLevel Source #

Constructors

Never |
ForModify |
ForRead |

#### Instances

Instances details

Read AuthenticationLevel Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS AuthenticationLevel Source # readList :: ReadS [AuthenticationLevel] Source # readPrec :: ReadPrec AuthenticationLevel Source # readListPrec :: ReadPrec [AuthenticationLevel] Source #
Show AuthenticationLevel Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> AuthenticationLevel -> ShowS Source # show :: AuthenticationLevel -> String Source # showList :: [AuthenticationLevel] -> ShowS Source #
Eq AuthenticationLevel Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source # (/=) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source #
Ord AuthenticationLevel Source # |

Instance details

Defined in Network.Gitit.Types

Methods

compare :: AuthenticationLevel -> AuthenticationLevel -> Ordering Source #

(<) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source #

(<=) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source #

(>) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source #

(>=) :: AuthenticationLevel -> AuthenticationLevel -> Bool Source #

max :: AuthenticationLevel -> AuthenticationLevel -> AuthenticationLevel Source #

min :: AuthenticationLevel -> AuthenticationLevel -> AuthenticationLevel Source #

data Config Source #

Data structure for information read from config file.

Constructors

Config |

Fields

- repositoryPath :: FilePath

  Path of repository containing filestore

- repositoryType :: FileStoreType

  Type of repository

- defaultPageType :: PageType

  Default page markup type for this wiki

- defaultExtension :: String

  Default file extension for pages in this wiki

- mathMethod :: MathMethod

  How to handle LaTeX math in pages?

- defaultLHS :: Bool

  Treat as literate haskell by default?

- showLHSBirdTracks :: Bool

  Show Haskell code with bird tracks

- withUser :: Handler -> Handler

  Combinator to set `REMOTE_USER` request header

- requireAuthentication :: AuthenticationLevel

  Handler for login, logout, register, etc.

- authHandler :: Handler

  Specifies which actions require authentication.

- userFile :: FilePath

  Path of users database

- sessionTimeout :: Int

  Seconds of inactivity before session expires

- templatesDir :: FilePath

  Directory containing page templates

- logFile :: FilePath

  Path of server log file

- logLevel :: Priority

  Severity filter for log messages (DEBUG, INFO, NOTICE, WARNING, ERROR, CRITICAL, ALERT, EMERGENCY)

- staticDir :: FilePath

  Path of static directory

- pluginModules :: [String]

  Names of plugin modules to load

- tableOfContents :: Bool

  Show table of contents on each page?

- maxUploadSize :: Integer

  Max size of file uploads

- maxPageSize :: Integer

  Max size of page uploads

- address :: String

  IP address to bind to

- portNumber :: Int

  Port number to serve content on

- debugMode :: Bool

  Print debug info to the console?

- frontPage :: String

  The front page of the wiki

- noEdit :: [String]

  Pages that cannot be edited via web

- noDelete :: [String]

  Pages that cannot be deleted via web

- defaultSummary :: String

  Default summary if description left blank

- deleteSummary :: String

  Delete summary

- accessQuestion :: Maybe (String, [String])

  `Nothing` = anyone can register. `Just (prompt, answers)` = a user will be given the prompt and must give one of the answers to register.

- disableRegistration :: Bool

  Disable Registration?

- useRecaptcha :: Bool

  Use ReCAPTCHA for user registration.

- recaptchaPublicKey :: String
- recaptchaPrivateKey :: String
- rpxDomain :: String

  RPX domain and key

- rpxKey :: String
- compressResponses :: Bool

  Should responses be compressed?

- useCache :: Bool

  Should responses be cached?

- cacheDir :: FilePath

  Directory to hold cached pages

- mimeMap :: Map String String

  Map associating mime types with file extensions

- mailCommand :: String

  Command to send notification emails

- resetPasswordMessage :: String

  Text of password reset email

- markupHelp :: Text

  Markup syntax help for edit sidebar

- useFeed :: Bool

  Provide an atom feed?

- baseUrl :: String

  Base URL of wiki, for use in feed

- useAbsoluteUrls :: Bool

  Title of wiki, used in feed

- wikiTitle :: String

  Should WikiLinks be absolute w.r.t. the base URL?

- feedDays :: Integer

  Number of days history to be included in feed

- feedRefreshTime :: Integer

  Number of minutes to cache feeds before refreshing

- pandocUserData :: Maybe FilePath

  Directory to search for pandoc customizations

- xssSanitize :: Bool

  Filter HTML through xss-sanitize

- recentActivityDays :: Int

  The default number of days in the past to look for "recent" activity

- githubAuth :: GithubConfig

  Github client data for authentication (id, secret, callback, authorize endpoint, access token endpoint)

data Page Source #

Data for rendering a wiki page.

Constructors

Page |

Fields

- pageName :: String
- pageFormat :: PageType
- pageLHS :: Bool
- pageTOC :: Bool
- pageTitle :: String
- pageCategories :: [String]
- pageText :: String
- pageMeta :: [(String, String)]

#### Instances

Instances details

Read Page Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS Page Source # readList :: ReadS [Page] Source # readPrec :: ReadPrec Page Source # readListPrec :: ReadPrec [Page] Source #
Show Page Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Page -> ShowS Source # show :: Page -> String Source # showList :: [Page] -> ShowS Source #

newtype SessionKey Source #

Constructors

SessionKey Integer |

#### Instances

Instances details

Read SessionKey Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS SessionKey Source # readList :: ReadS [SessionKey] Source # readPrec :: ReadPrec SessionKey Source # readListPrec :: ReadPrec [SessionKey] Source #
Show SessionKey Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> SessionKey -> ShowS Source # show :: SessionKey -> String Source # showList :: [SessionKey] -> ShowS Source #
Eq SessionKey Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: SessionKey -> SessionKey -> Bool Source # (/=) :: SessionKey -> SessionKey -> Bool Source #
Ord SessionKey Source # |

Instance details

Defined in Network.Gitit.Types

Methods

compare :: SessionKey -> SessionKey -> Ordering Source #

(<) :: SessionKey -> SessionKey -> Bool Source #

(<=) :: SessionKey -> SessionKey -> Bool Source #

(>) :: SessionKey -> SessionKey -> Bool Source #

(>=) :: SessionKey -> SessionKey -> Bool Source #

max :: SessionKey -> SessionKey -> SessionKey Source #

min :: SessionKey -> SessionKey -> SessionKey Source #

FromReqURI SessionKey Source # |
Instance details Defined in Network.Gitit.Types Methods fromReqURI :: String -> Maybe SessionKey Source #
FromData SessionKey Source # |
Instance details Defined in Network.Gitit.Types Methods fromData :: RqData SessionKey Source #

data SessionData Source #

#### Instances

Instances details

Read SessionData Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS SessionData Source # readList :: ReadS [SessionData] Source # readPrec :: ReadPrec SessionData Source # readListPrec :: ReadPrec [SessionData] Source #
Show SessionData Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> SessionData -> ShowS Source # show :: SessionData -> String Source # showList :: [SessionData] -> ShowS Source #
Eq SessionData Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: SessionData -> SessionData -> Bool Source # (/=) :: SessionData -> SessionData -> Bool Source #

data SessionGithubData Source #

#### Instances

Instances details

Read SessionGithubData Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS SessionGithubData Source # readList :: ReadS [SessionGithubData] Source # readPrec :: ReadPrec SessionGithubData Source # readListPrec :: ReadPrec [SessionGithubData] Source #
Show SessionGithubData Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> SessionGithubData -> ShowS Source # show :: SessionGithubData -> String Source # showList :: [SessionGithubData] -> ShowS Source #
Eq SessionGithubData Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: SessionGithubData -> SessionGithubData -> Bool Source # (/=) :: SessionGithubData -> SessionGithubData -> Bool Source #

sessionData :: String -> SessionData Source #

sessionGithubData :: SessionData -> Maybe SessionGithubData Source #

sessionDataGithubStateUrl :: String -> String -> SessionData Source #

sessionUser :: SessionData -> Maybe String Source #

sessionGithubState :: SessionGithubData -> String Source #

sessionGithubDestination :: SessionGithubData -> String Source #

data User Source #

Constructors

User |

Fields

- uUsername :: String
- uPassword :: Password
- uEmail :: String

#### Instances

Instances details

Read User Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS User Source # readList :: ReadS [User] Source # readPrec :: ReadPrec User Source # readListPrec :: ReadPrec [User] Source #
Show User Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> User -> ShowS Source # show :: User -> String Source # showList :: [User] -> ShowS Source #

data Sessions a Source #

Constructors

Sessions |

Fields

- unsession :: Map SessionKey a

#### Instances

Instances details

Read a => Read (Sessions a) Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS (Sessions a) Source # readList :: ReadS [Sessions a] Source # readPrec :: ReadPrec (Sessions a) Source # readListPrec :: ReadPrec [Sessions a] Source #
Show a => Show (Sessions a) Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Sessions a -> ShowS Source # show :: Sessions a -> String Source # showList :: [Sessions a] -> ShowS Source #
Eq a => Eq (Sessions a) Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: Sessions a -> Sessions a -> Bool Source # (/=) :: Sessions a -> Sessions a -> Bool Source #

data Password Source #

Constructors

Password |

Fields

- pSalt :: String
- pHashed :: String

#### Instances

Instances details

Read Password Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS Password Source # readList :: ReadS [Password] Source # readPrec :: ReadPrec Password Source # readListPrec :: ReadPrec [Password] Source #
Show Password Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Password -> ShowS Source # show :: Password -> String Source # showList :: [Password] -> ShowS Source #
Eq Password Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: Password -> Password -> Bool Source # (/=) :: Password -> Password -> Bool Source #

data GititState Source #

Common state for all gitit wikis in an application.

Constructors

GititState |

Fields

- sessions :: Sessions SessionData
- users :: Map String User
- templatesPath :: FilePath
- renderPage :: PageLayout -> Html -> Handler
- plugins :: [Plugin]

class Monad m => HasContext m Source #

Minimal complete definition

getContext, modifyContext

#### Instances

Instances details

HasContext ContentTransformer Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: ContentTransformer Context Source # modifyContext :: (Context -> Context) -> ContentTransformer () Source #
HasContext PluginM Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: PluginM Context Source # modifyContext :: (Context -> Context) -> PluginM () Source #

modifyContext :: HasContext m => (Context -> Context) -> m () Source #

getContext :: HasContext m => m Context Source #

type ContentTransformer = StateT Context GititServerPart Source #

data Plugin Source #

Constructors

PageTransform (Pandoc -> PluginM Pandoc) |
PreParseTransform (String -> PluginM String) |
PreCommitTransform (String -> PluginM String) |

data PluginData Source #

Constructors

PluginData |

Fields

- pluginConfig :: Config
- pluginUser :: Maybe User
- pluginRequest :: Request
- pluginFileStore :: FileStore

#### Instances

Instances details

HasContext PluginM Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: PluginM Context Source # modifyContext :: (Context -> Context) -> PluginM () Source #

type PluginM = ReaderT PluginData (StateT Context IO) Source #

runPluginM :: PluginM a -> PluginData -> Context -> IO (a, Context) Source #

data Context Source #

Constructors

Context |

Fields

- ctxFile :: String
- ctxLayout :: PageLayout
- ctxCacheable :: Bool
- ctxTOC :: Bool
- ctxBirdTracks :: Bool
- ctxCategories :: [String]
- ctxMeta :: [(String, String)]

#### Instances

Instances details

HasContext ContentTransformer Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: ContentTransformer Context Source # modifyContext :: (Context -> Context) -> ContentTransformer () Source #
HasContext PluginM Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: PluginM Context Source # modifyContext :: (Context -> Context) -> PluginM () Source #

data PageLayout Source #

Abstract representation of page layout (tabs, scripts, etc.)

Constructors

PageLayout |

Fields

- pgPageName :: String
- pgRevision :: Maybe String
- pgPrintable :: Bool
- pgMessages :: [String]
- pgTitle :: String
- pgScripts :: [String]
- pgShowPageTools :: Bool
- pgShowSiteNav :: Bool
- pgMarkupHelp :: Maybe Text
- pgTabs :: [Tab]
- pgSelectedTab :: Tab
- pgLinkToFeed :: Bool

data Tab Source #

Constructors

ViewTab |
EditTab |
HistoryTab |
DiscussTab |
DiffTab |

#### Instances

Instances details

Show Tab Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Tab -> ShowS Source # show :: Tab -> String Source # showList :: [Tab] -> ShowS Source #
Eq Tab Source # |
Instance details Defined in Network.Gitit.Types Methods (==) :: Tab -> Tab -> Bool Source # (/=) :: Tab -> Tab -> Bool Source #

data Recaptcha Source #

Constructors

Recaptcha |

Fields

- recaptchaChallengeField :: String
- recaptchaResponseField :: String

#### Instances

Instances details

Read Recaptcha Source # |
Instance details Defined in Network.Gitit.Types Methods readsPrec :: Int -> ReadS Recaptcha Source # readList :: ReadS [Recaptcha] Source # readPrec :: ReadPrec Recaptcha Source # readListPrec :: ReadPrec [Recaptcha] Source #
Show Recaptcha Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Recaptcha -> ShowS Source # show :: Recaptcha -> String Source # showList :: [Recaptcha] -> ShowS Source #

data Params Source #

Constructors

Params |

Fields

- pUsername :: String
- pPassword :: String
- pPassword2 :: String
- pRevision :: Maybe String
- pDestination :: String
- pForUser :: Maybe String
- pSince :: Maybe UTCTime
- pRaw :: String
- pLimit :: Int
- pPatterns :: [String]
- pGotoPage :: String
- pFileToDelete :: String
- pEditedText :: Maybe String
- pMessages :: [String]
- pFrom :: Maybe String
- pTo :: Maybe String
- pFormat :: String
- pSHA1 :: String
- pLogMsg :: String
- pEmail :: String
- pFullName :: String
- pAccessCode :: String
- pWikiname :: String
- pPrintable :: Bool
- pOverwrite :: Bool
- pFilename :: String
- pFilePath :: FilePath
- pConfirm :: Bool
- pSessionKey :: Maybe SessionKey
- pRecaptcha :: Recaptcha
- pResetCode :: String
- pRedirect :: Maybe Bool

#### Instances

Instances details

Show Params Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Params -> ShowS Source # show :: Params -> String Source # showList :: [Params] -> ShowS Source #
FromData Params Source # |
Instance details Defined in Network.Gitit.Types Methods fromData :: RqData Params Source #

data Command Source #

Constructors

Command (Maybe String) |

#### Instances

Instances details

Show Command Source # |
Instance details Defined in Network.Gitit.Types Methods showsPrec :: Int -> Command -> ShowS Source # show :: Command -> String Source # showList :: [Command] -> ShowS Source #
FromData Command Source # |
Instance details Defined in Network.Gitit.Types Methods fromData :: RqData Command Source #

data WikiState Source #

State for a single wiki.

Constructors

WikiState |

Fields

- wikiConfig :: Config
- wikiFileStore :: FileStore

#### Instances

Instances details

HasContext ContentTransformer Source # |
Instance details Defined in Network.Gitit.Types Methods getContext :: ContentTransformer Context Source # modifyContext :: (Context -> Context) -> ContentTransformer () Source #

type GititServerPart = ServerPartT (ReaderT WikiState IO) Source #

type Handler = GititServerPart Response Source #

fromEntities :: String -> String Source #

data GithubConfig Source #

oAuth2 :: GithubConfig -> OAuth2 Source #

org :: GithubConfig -> Maybe Text Source #

githubConfig :: OAuth2 -> Maybe Text -> GithubConfig Source #